"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = reactFelaAdapter;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function stringifyDeclaration(declaration) {
  var prop = '"' + declaration.property + '":';

  if (_typeof(declaration.value) === 'object') {
    return prop + '{' + declaration.value.map(stringifyDeclaration).join(',\n') + '}';
  }

  return prop + 'props.' + declaration.value;
}

function reactFelaAdapter(_ref) {
  var style = _ref.style,
      variantStyleMap = _ref.variantStyleMap,
      moduleName = _ref.moduleName,
      classNameMap = _ref.classNameMap,
      resetClassName = _ref.resetClassName,
      className = _ref.className,
      dynamicImport = _ref.dynamicImport;
  var hasVariations = Object.keys(classNameMap).length > 1;
  var hasDynamicVariations = Object.keys(variantStyleMap).length > 0;
  var imports = [hasVariations ? 'getClassNameFromVariantMap' : undefined, hasDynamicVariations ? 'getDynamicStyleFromVariantMap' : undefined].filter(Boolean);
  return (!dynamicImport ? "import './" + moduleName + ".elo.css'\n" : '') + (imports.length > 0 ? 'import { ' + imports.join(', ') + " } from '@elodin/runtime'\n" : '') + "import { createComponent } from 'react-fela'\n\n" + (hasVariations ? 'const variantMap = ' + JSON.stringify(classNameMap, null, 2) + '\n\n' : '') + (hasDynamicVariations ? 'const variantStyleMap = {\n' + Object.keys(variantStyleMap).map(function (modifier) {
    return "'" + modifier + "'" + ': props => ({\n  ' + variantStyleMap[modifier].map(stringifyDeclaration).join(',\n  ') + '\n})';
  }).join(',\n') + '\n}' + '\n\n' : '') + 'function ' + moduleName + 'Style' + '(props  = {})' + ' {\n  ' + (dynamicImport ? "import('./" + moduleName + ".elo.css')\n" : '') + 'return {\n    ' + '_className: ' + (hasVariations ? "'" + resetClassName + " ' + " + "getClassNameFromVariantMap('" + className + "', variantMap, props)" : "'" + resetClassName + ' ' + className + "'") + ',\n    ' + style.map(stringifyDeclaration).join(',\n    ') + (hasDynamicVariations ? ',\n    ...getDynamicStyleFromVariantMap(variantStyleMap, props)' : '') + '\n  }\n}\n\n' + 'export const ' + moduleName + ' = createComponent(' + moduleName + 'Style' + ')';
}